// Code generated by MockGen. DO NOT EDIT.
// Source: rate_limiter.go
//
// Generated by this command:
//
//	mockgen -typed -source rate_limiter.go -destination rate_limiter_mock_for_test.go -package engine
//

// Package engine is a generated GoMock package.
package engine

import (
	context "context"
	reflect "reflect"

	gomock "go.uber.org/mock/gomock"
)

// MockAllowLimiter is a mock of AllowLimiter interface.
type MockAllowLimiter struct {
	ctrl     *gomock.Controller
	recorder *MockAllowLimiterMockRecorder
	isgomock struct{}
}

// MockAllowLimiterMockRecorder is the mock recorder for MockAllowLimiter.
type MockAllowLimiterMockRecorder struct {
	mock *MockAllowLimiter
}

// NewMockAllowLimiter creates a new mock instance.
func NewMockAllowLimiter(ctrl *gomock.Controller) *MockAllowLimiter {
	mock := &MockAllowLimiter{ctrl: ctrl}
	mock.recorder = &MockAllowLimiterMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockAllowLimiter) EXPECT() *MockAllowLimiterMockRecorder {
	return m.recorder
}

// Allow mocks base method.
func (m *MockAllowLimiter) Allow(ctx context.Context) bool {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Allow", ctx)
	ret0, _ := ret[0].(bool)
	return ret0
}

// Allow indicates an expected call of Allow.
func (mr *MockAllowLimiterMockRecorder) Allow(ctx any) *MockAllowLimiterAllowCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Allow", reflect.TypeOf((*MockAllowLimiter)(nil).Allow), ctx)
	return &MockAllowLimiterAllowCall{Call: call}
}

// MockAllowLimiterAllowCall wrap *gomock.Call
type MockAllowLimiterAllowCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockAllowLimiterAllowCall) Return(arg0 bool) *MockAllowLimiterAllowCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockAllowLimiterAllowCall) Do(f func(context.Context) bool) *MockAllowLimiterAllowCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockAllowLimiterAllowCall) DoAndReturn(f func(context.Context) bool) *MockAllowLimiterAllowCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}
